<?php
 //========================================================
 // MODIFIED: 10/01/2004 BY TERRY REESE
 // DO NOT CHANGE THIS FILE WITHOUT DOING THE FOLLOWING:
 //   1) LETTING TERRY REESE (terry.reese@oregonstate.edu)
 //      OR THE INDIVIDUAL RESPONSIBLE FOR WEBBRIDGE LINK 
 //      MAINTANENCE AWARE OF THE MODIFICATIONS
 //   2) TESTING THE CHANGES ON A TEST SCRIPT.
 //      ALL THE JOURNALS USING DOIS ARE RESOVLED USING
 //      THIS SCRIPT.
 //======================================================= 
 $errorURL= "no_resolve.php?url=";
 function CreateProxy($u) {

   if (is_integer(strpos($u, "http://"))) {
      preg_match("/http:\/\/(.*?):{0,1}([0-9]*)(\/)(.*)/i", $u, $matches);
      $stem = "http://";
   } else {
      preg_match("/https:\/\/(.*?):{0,1}([0-9]*)(\/)(.*?)/i", $u, $matches);
      //print "<!--match 2-->";
      $stem = "https://";
   }
   $port = ($matches[2])?$matches[2]:0;
   //print $matches[1];
   if (strlen($matches[1])!=0) {
      $returnUrl = $stem .$port."-".$matches[1].".oasis.oregonstate.edu/".$matches[4];
   } else {
      $returnUrl = $stem .$port."-".substr($addr,strlen($stem)).".oasis.oregonstate.edu/";
   }
   return $returnUrl;

 }

 function ResolveRequest($u) {
   if (substr($u, 0, strlen("http://"))=="http://") {
	$u = substr($u, strlen("http://"));
   }
   $lindex = strpos($u, "/");
   $lhost = substr($u,0, $lindex);
   $luri = substr($u,$lindex + 1);
   return array($lhost, $luri);

 }

 function getURL($host, $uri) {
 // Get A Socket Handler (Time Out = 5 sec)
 $stream = fsockopen($host, 80, $errno, $errstr, 5);

 // Check Stream And Throw Error If Necessary
 if (!$stream) {
	return "";
        die;
        //die("Network error: $errstr ($errno)");
 } else {
        $head = "";
        $finished = false;

        // Use Socket Handler To Do An HTTP Get Request
        fputs($stream, "GET /$uri HTTP/1.1\r\nHost: $host\r\n\r\n");

        // Parse The HTTP Get Request Response
        while (!feof($stream)) {

                $s = fgets($stream, 128);

                // Check If This Is The Header's End
                if ($s=="\r\n") {break;}

                if (!$finished) {$head .= $s;}
        }

        // Close Socket Handler
        fclose ($stream);

        // Print Collected HTTP Header
        $head = str_replace("\r\n", "\n", $head);
	$theader = str_replace("\n", "<br>", $head);
        $arr = explode("\n", $head);
        foreach ($arr as $line) {
 	   if (strtolower(substr($line, 0, strlen("Location:"))) == "location:")  {
		$head = substr($line, strlen("Location:"));
		$head = trim($head, ": ");
    		return $head;
		break;
	   }
        }
 	return "";
             
  }
 }


$url = $_SERVER['QUERY_STRING'];
$id = "";
if (isset($_GET['id'])) {
    $id = urldecode($_GET['id']);
    if (is_integer(strpos($id, "doi:"))) {
      $id = str_replace("doi:", "", $id);
      $id = trim($id);
    }
}

if ($id!='') {
    $doi = $id;
    $doi = trim($doi);
    $url = "http://dx.doi.org/" . $doi;
    list($ghost, $guri) = ResolveRequest($url);

    $url = getURL($ghost, $guri);
    if ($url!="") {
        $url = CreateProxy($url);
        header("Location: " . $url);
    } else {
        header("Location: " . $errorURL . $_SERVER['QUERY_STRING']);
    }
} else {

 if (is_integer(strpos($url, "&url=")))  {
   $url = substr($url, strpos($url, "&url=")+strlen("&url="));
 } else {
   $url = substr($url, strpos($url, "=") + 1);
 }
 $url = urldecode($url);
 list($ghost, $guri) = ResolveRequest($url);
 $url = getURL($ghost, $guri);
 if ($url!="") {
   list ($ghost, $guri) = ResolveRequest($url);
   $url = getURL($ghost, $guri); 
   if ($url!="") {
     $url = CreateProxy($url);
     header("Location: " . $url);
   } else {
      header("Location: " . $errorURL . $_SERVER['QUERY_STRING']); 
   }

 } else {
   header("Location: " . $errorURL . $_SERVER['QUERY_STRING']);
 }
} 
 
?>
